from DateTime import DateTime
import zLOG, os
import re, random
from urllib import quote_plus
from cStringIO import StringIO
from Products.CMFCore.utils import getToolByName

def cookId(id):
    if not id:
        id = str(DateTime().millis()) + str(random.randint(0, 1000000))
    else:
        rgx = re.compile(r'(^_|[^a-zA-Z0-9-_~\,\.])')
        id = re.sub(rgx, "",id)
    return id
    
def getUniqueID():
    return cookId(id=None)

def urlencode(str):
    return quote_plus(str)

def gotattr(obj, attr):
    return hasattr(obj, attr)

def getTransitions(self):
    out = StringIO()
    #out.write('Testing Get Transitions\n')
    #out.write('-----------------------\n\n')
    wf_tool = getToolByName(self, 'portal_workflow')
    transitionlist = []
    for id in wf_tool.getWorkflowIds():
        #out.write('ID: %s\n' % id)
        if id != 'collector_issue_workflow':
            wf = wf_tool.getWorkflowById(id)
            #out.write('Workflow dict: %s\n' % str(wf.__dict__))
            if hasattr(wf, 'transitions'):
                #out.write('Transitions dict: %s\n' % str(wf.transitions.__dict__))
                if hasattr(wf.transitions, '_mapping'):
                    for transition in wf.transitions._mapping.keys():
                        transition_dict = {}
                        tlist_def = wf.transitions._mapping[transition]
                        tranid = tlist_def.getId()
                        guard = tlist_def.getGuard()
                        #out.write('Guard Definition dict for transition %s: %s\n' % (str(tranid), str(guard.__dict__)))
                        #out.write('Transition list: %s\n\n' % str(tlist_def))
                        a_tlist = {'id': tranid
                        ,}
                        name =  getattr(tlist_def, 'actbox_name', None)
                        if name: a_tlist['name'] = name
                        transition_dict['id'] = tranid
                        transition_dict['name'] = name
                        transition_dict['permission'] = guard.permissions
                        transition_dict['roles'] = guard.roles
                        transitionlist.append(transition_dict)

    actionlist = []
    for dict in transitionlist:
        add_new = 1
        for final_dict in actionlist:
            if final_dict['id'] == dict['id']:
                add_new = 0
        if add_new:
            new_dict = {}
            new_dict['id'] = dict['id']
            new_dict['name'] = dict['name']
            permlist = []
            for perm in dict['permission']:
                permlist.append(perm)
            new_dict['permission'] = permlist
            roleslist = []
            for role in dict['roles']:
                roleslist.append(role)
            new_dict['roles'] = roleslist
            actionlist.append(new_dict)

    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))

    if not actionlist:
        actionlist = [{'id': 'publish'
                     , 'name': 'Publish'
                     , 'permission': ['Review portal content']
                      }
                    , {'id': 'submit'
                     , 'name': 'Submit'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'retract'
                     , 'name': 'Retract'
                     , 'permission': ['Request review']
                      }
                    , {'id': 'reject'
                     , 'name': 'Reject'
                     , 'permission': ['Review portal content']
                      }]

    zLOG.LOG('Get transitions', zLOG.INFO, 'Action list is: %s' % str(actionlist))
    return actionlist
